<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Exception;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use ACL\Helpers\Instances\InstanceProvider;
use ACL\Util\AclUtilities;
use ACL\Services\Paramgeral as ParamgeralService;

class Paramgeral {

    use TResponse;

    /**
     * @var ParamgeralService
     */
    private $paramgeralService;

    /**
     * Paramgeral constructor.
     * @param ParamgeralService $paramgeralService
     */
    public function __construct(ParamgeralService $paramgeralService)
    {
        $this->paramgeralService = $paramgeralService;
    }

    /**
     * @param Request $request
     * @param Response $response
     * @throws Exception
     */
    public function findParamgeral(Request $request, Response $response)
    {
        try {
            $data = $this->paramgeralService->findParamgeral();
            $this->sendResponse($data, 200);
        } catch (Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }
}
