/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8140_SUPTRGO_APAGA_CUSTO.SQL

Descrio:
Apagar pr-custo de cotao no disponibilizada para lista de preos.

Criao:
29/06/2005 Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER APAGA_CUSTO
BEFORE UPDATE
ON COLETAPR FOR EACH ROW
BEGIN
   IF NVL(:OLD.IDDISMONTLIS, 'S') <> NVL(:NEW.IDDISMONTLIS, 'S') THEN
      IF NVL(:NEW.IDDISMONTLIS, 'S') = 'N' THEN
         FOR C_COTACAO IN
            (SELECT
                ITEMCOLE.CDFILIAL,
                ITEMCOLE.NRCOLEPRECO,
                ITEMCOLE.CDFORNECED,
                ITEMCOLE.CDREGIAO,
                ITEMCOLE.CDPRODUTO,
                ITEMCOLE.CDMARCA
             FROM
                ITEMCOLE
             WHERE
                ITEMCOLE.CDFILIAL               = :NEW.CDFILIAL    AND
                ITEMCOLE.NRCOLEPRECO            = :NEW.NRCOLEPRECO
             )
         LOOP
            DELETE FROM
               CUSTOSUP
            WHERE
               CUSTOSUP.CDFILCOTLIST = C_COTACAO.CDFILIAL        AND
               CUSTOSUP.NRCOLEPRLIST = C_COTACAO.NRCOLEPRECO     AND
               CUSTOSUP.CDMARCALIST  = C_COTACAO.CDMARCA         AND
               CUSTOSUP.CDREGIAOLIST = C_COTACAO.CDREGIAO        AND
               CUSTOSUP.CDFORNECLIST = C_COTACAO.CDFORNECED      AND
               CUSTOSUP.CDPRODLIST   = C_COTACAO.CDPRODUTO       AND
               CUSTOSUP.VRPRCUSTOAF IS NULL                      AND
               CUSTOSUP.NRCOLEPRACOR IS NULL;
            IF SQL%ROWCOUNT = 0 THEN
               UPDATE CUSTOSUP
               SET
                  VRHISPRLISTP = NULL,
                  VRCUSPRLISTP = NULL,
                  VRCUSPRLISM1 = NULL,
                  VRCUSPRLISM2 = NULL,
                  CDFILCOTLIST = NULL,
                  NRCOLEPRLIST = NULL,
                  CDMARCALIST  = NULL,
                  CDREGIAOLIST = NULL,
                  CDFORNECLIST = NULL,
                  CDPRODLIST   = NULL
               WHERE
                  CUSTOSUP.CDFILCOTLIST = C_COTACAO.CDFILIAL        AND
                  CUSTOSUP.NRCOLEPRLIST = C_COTACAO.NRCOLEPRECO     AND
                  CUSTOSUP.CDMARCALIST  = C_COTACAO.CDMARCA         AND
                  CUSTOSUP.CDREGIAOLIST = C_COTACAO.CDREGIAO        AND
                  CUSTOSUP.CDFORNECLIST = C_COTACAO.CDFORNECED      AND
                  CUSTOSUP.CDPRODLIST   = C_COTACAO.CDPRODUTO       AND
                  CUSTOSUP.NRCOLEPRACOR IS NULL;
            END IF;
         END LOOP;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('APAGA_CUSTO','4.05.041'); END;
/

